<?php 
/*
* Plugin Name : Generate Custom Template
* Plugin Author : Syed Umair Hussain Shah
* Support : go to umairshahblog.blogspot.com
*/
function GCTFormPage()
{
	ini_set('max_execution_time', 5000);
	$GCT_Template_Name = "";
	$GCT_Template_File_Name = "";
	$GCT_Template_Content = "";
	$error = "";
	if(isset($_POST['GCT_Submit']) && 
	isset($_POST['action']) &&
	isset($_POST['nonce']) &&
	$_POST['action'] === 'gct-form-submit' &&
	wp_verify_nonce($_POST['nonce'], 'GCT_Form_Request') &&
	current_user_can( 'manage_options' ))
	{
		global $wpdb;
		$GCT_Template_Name = (isset($_POST['GCT_Template_Name']) && !empty($_POST['GCT_Template_Name']) ? sanitize_text_field(preg_replace('/[^A-Za-z0-9- ]/', '', $_POST['GCT_Template_Name'])) : '');
		$GCT_Template_File_Name = (isset($_POST['GCT_Template_File_Name']) && !empty($_POST['GCT_Template_File_Name']) ? sanitize_text_field(preg_replace('/[^A-Za-z0-9- ]/', '', $_POST['GCT_Template_File_Name'])) : '');
		$GCT_Template_Content = (isset($_POST['GCT_Template_Content']) && !empty($_POST['GCT_Template_Content']) ? wp_specialchars_decode($_POST['GCT_Template_Content'], $quote_style = ENT_QUOTES ) : '');

		$GCT_Custom_Template =  array(
			'template_name'         => $GCT_Template_Name, 
			'template_file_name'    => $GCT_Template_File_Name, 
			'template_content'      => $GCT_Template_Content
		);

		if((empty($GCT_Template_Name) && !isset($GCT_Template_Name))
		|| (empty($GCT_Template_File_Name) && !isset($GCT_Template_File_Name)))
		{
			$error = "Please fill all fields carefully";
		}
		else
		{	
			$format = array('%s','%s','%s');
			$wpdb->insert("{$wpdb->prefix}gct_content", $GCT_Custom_Template, $format);
		}

		$file = get_template_directory() ."/".str_replace(" ","-", strtolower($GCT_Template_File_Name)).".php";
		$createFile = fopen($file, "w") or die("Unable to create file!");
		$text = "<?php /* Template Name: ".$GCT_Template_Name." */ ?>";
		if(!empty($GCT_Template_Content) && isset($GCT_Template_Content)):	
			$text .= "\n".$GCT_Template_Content;
		endif;
		fwrite($createFile, $text);
		fclose($createFile);
		echo'<script>window.location.href="'.admin_url( 'admin.php?page=generate_template_plugin_listing' ).'"</script>'; 
		exit();
	}
	?>
	<style>
	.gct-input{overflow: hidden; overflow-wrap: break-word; resize: none; height: 39px;width:500px}
	.gct-textarea{overflow: hidden; overflow-wrap: break-word; resize: none; height: 100px;width:500px}
	</style>
	<div id="Messages">
		<div id="error" class="DisplayNone" style="display: none; border: 1px solid red;background-color: pink;padding: 12px;color: white;">
			<?php 
				if(!empty($error) && isset($error))
				{
					echo $error;
				}
			?>
		</div>
		<div id="success" class="DisplayNone"></div>
	</div>
	<form method="post" id="GCT_Custom_Template">
		<table>
		<tr><td>Template Name : </td><td> <input type="text" class="gct-input" name="GCT_Template_Name" id="GCT_Template_Name" valid="true" placeholder="Template Name" error="Please enter template name" value="<?php echo (!empty($GCT_Template_Name) ? $GCT_Template_Name : ''); ?>" /></td></tr>
		<tr><td>Template File Name : </td><td><input type="text" class="gct-input" name="GCT_Template_File_Name" id="GCT_Template_File_Name" placeholder="Template File Name" valid="true" error="Please enter template file name" value="<?php echo (!empty($GCT_Template_File_Name) ? $GCT_Template_File_Name : ''); ?>" /></td><td>hint : please enter template file name without .php extension</tr>
		<tr><td>Template Content : </td><td><textarea type="text" class="gct-textarea" name="GCT_Template_Content" id="GCT_Template_Content" placeholder="Template Content"><?php echo (!empty($GCT_Template_Content) ? $GCT_Template_Content : ''); ?></textarea></td></tr>
		<input type="hidden" name="nonce" value="<?php echo wp_create_nonce( 'GCT_Form_Request' ); ?>"  />
		<input type="hidden" name="action" value="gct-form-submit"  />
		<tr><td></td><td><input type="submit" name="GCT_Submit" class="button button-primary" onclick="return FormValidator('#GCT_Custom_Template');"  value="Create New Template"></td></tr>
		</table>
	</form>

	<script type="text/javascript">
		function FormValidator(FormID)
		{
			jQuery(FormID).find('input[type="text"],input[type="email"],input[type="date"],input[type="password"],input[type="tel"], select, textarea').each(function(){
				if(jQuery(this).attr('valid') == 'true' && jQuery(this).val() == "")
				{
					jQuery(this).addClass('error');
					jQuery(this).parents().find('#error').addClass('DisplayBlock');
					jQuery(this).parents().find('#error').html(jQuery(this).attr('error')+'<br>').show();
					return false;
				}else{
					jQuery(this).removeClass('error');
					if(!jQuery('.error').length)
					{
						jQuery(this).parents().find('#error').removeClass('DisplayBlock');
					}
				}
			});

			jQuery(FormID).find('.checkbox').each(function(){

				if(jQuery(this).attr('valid') == 'true' && jQuery(this).find('input[type="checkbox"]').is(':checked') == false)
				{
					jQuery(this).addClass('error');
					jQuery(this).parents().find('#error').addClass('DisplayBlock');
					jQuery(this).parents().find('#error').html(jQuery(this).attr('error')+'<br>');
				}else{
					jQuery(this).removeClass('error');
					if(!jQuery('.error').length)
					{
						jQuery(this).parents().find('#error').removeClass('DisplayBlock');
					}
				}
			});

			jQuery(FormID).find('.radio').each(function(){

				if(jQuery(this).attr('valid') == 'true' &&  jQuery(this).find('input[type="radio"]').is(':checked') == false)
				{
					jQuery(this).addClass('error');
					jQuery(this).parents().find('#error').addClass('DisplayBlock');
					jQuery(this).parents().find('#error').html(jQuery(this).attr('error')+'<br>');
				}else{
					jQuery(this).removeClass('error');
					if(!jQuery('.error').length)
					{
						jQuery(this).parents().find('#error').removeClass('DisplayBlock');
					}
				}
			});
			
			if(jQuery('#error').length && jQuery('.error').length)
			{
				return false;
			}
			else
			{
				return;
			}
		}
	</script>
<?php 
}
?>