<?php 

	/**
	* Plugin Name: Generate Custom Template
	* Plugin URI: https://umairshahblog.blogspot.com/generate-custom-template
	* Description: generate custom template using wordpress admin dashboard  
	* Version: 1.0
	* Author: Syed Umair Hussain Shah
	* Author URI: https://umairshahblog.blogspot.com
	**/


	/***** No direct access to plugin PHP Files *****/
	defined( 'ABSPATH' ) or die( 'No script please!' );
	require_once( dirname( __FILE__ ) . '/admin/menu.php' );

	function Generate_Custom_Template_Activation()
	{
		global $wpdb;
		$table_name = $wpdb->prefix . 'gct_content';
		$sql = "DROP TABLE IF EXISTS $table_name; 
		CREATE TABLE $table_name(
			id int(11) PRIMARY KEY NOT NULL AUTO_INCREMENT,
			template_name varchar(255) NOT NULL,
			template_file_name varchar(255) NOT NULL,
			template_content text
		);";
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );

	}
	register_activation_hook(   __FILE__ , 'Generate_Custom_Template_Activation' );

	function Generate_Custom_Template_Uninstall()
	{
		global $wpdb;
		$table_name = $wpdb->prefix . 'gct_content';
		$sql = "DROP TABLE IF EXISTS $table_name";
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );
	}
	
	register_uninstall_hook(__FILE__, 'Generate_Custom_Template_Uninstall');

?>